
//	This source and fast ascii text file indexing method apply to GNU General Public License. 
//			Copyright (C) 2007 Jasenko Dzinleski 

//		This program is free software; you can redistribute it
//	and/or modify it under the terms of the GNU General Public License as
//	published by the Free Software Foundation; either version 2 of the
//	License, or (at your option) any later version. 

//	This program is distributed in the hope that it will be useful, but
//	WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
//	General Public License for more details. 

//	You should have received a copy of the GNU General Public License along
//	with this program; if not, write to the Free Software Foundation, Inc.,
//	51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.

//
//			ASCII Text File Indexing Routine
//			written by Dzinleski Jasenko September,2007
//


#include <stdio.h>
#include <string.h>

#define		posX	100
#define		posY	65000
#define		pos3X	500
#define		pos3Y	17000
#define		pos5X	500
#define		pos5Y	17000

char	infn[255]="iinput.txt";
char	outfn[255]="sorted.txt";

FILE	*msortf1,*msortf2;

long	lp[100000];
int	lpi=0;
long	lz[100000][4];
int	lzi=0;

int	ba161[16][16][16][16];
int	ba163[16][16][16][16];
int	ba165[16][16][16][16];

long	pos[posX][posY];
long	pos3[pos3X][pos3Y];
long	pos5[pos5X][pos5Y];

int	posi=0;
int	posi3=0;
int	posi5=0;

bool	df=false;


//int	msort_3()
int i1131(int ish)
{
	int	i,j,k,l,m,n,o,p,r,q;
	int	i3,j3,k3,l3;
	int	i5,j5,k5,l5;

	int	a,b,c,d;
	int	ah,al,bh,bl;
	int	ah3,al3,bh3,bl3;
	int	ah5,al5,bh5,bl5;

	long	lind;

	long	ln;

	char	fbyte;

	printf("\nASCII Text File Fast Sort/Indexing Routine\n");
	printf("written by Dzinleski Jasenko September,2007\n");
	printf("\nOS Win32 VRM 1.3.1\n\n");

	lpi=0;
	lzi=0;
	posi=0;
	posi3=0;
	posi5=0;

	msortf1=fopen(infn,"rb");

	fbyte=getc(msortf1);
	lp[lpi]=-1+ftell(msortf1);++lpi;	

	while(!feof(msortf1)&&lpi<100000)
	{
		//printf("%c",fbyte);
		while(!feof(msortf1)&&(int)fbyte!=13&&(int)fbyte!=10){fbyte=getc(msortf1);}
		while(((int)fbyte==13||(int)fbyte==10)&&!feof(msortf1)){fbyte=getc(msortf1);}
		lp[lpi]=-1+ftell(msortf1);++lpi;	
	}	
	fclose(msortf1);

	msortf1=fopen(infn,"rb");
	for(i=0;i<lpi;++i)
	{
		
		fseek(msortf1,lp[i],SEEK_SET);

		ln=0;l=0;m=0;
		while(l<2)
		{
			++l;
			fbyte=getc(msortf1);n=(int)fbyte;
			for(j=16-1;j>=0;--j)
			{
				if(((n<<(15-j))>>15)&0x1==1){m+=j;break;}
			}
			ln+=n<<(16-m-l);
		}
		lz[lzi][0]=lp[i];
		lz[lzi][1]=ln;
		//printf("%d ",ln);

		ln=0;l=0;m=0;
		while(l<2)
		{
			++l;
			fbyte=getc(msortf1);n=(int)fbyte;
			for(j=16-1;j>=0;--j)
			{
				if(((n<<(15-j))>>15)&0x1==1){m+=j;break;}
			}
			ln+=n<<(16-m-l);
		}
		lz[lzi][2]=ln;
		//printf("%d\n",ln);

		ln=0;l=0;m=0;
		while(l<2)
		{
			++l;
			fbyte=getc(msortf1);n=(int)fbyte;
			for(j=16-1;j>=0;--j)
			{
				if(((n<<(15-j))>>15)&0x1==1){m+=j;break;}
			}
			ln+=n<<(16-m-l);
		}
		lz[lzi][3]=ln;++lzi;
		//printf("%d\n",ln);

	}
	fclose(msortf1);

	for(i=0;i<posX;++i){for(j=0;j<posY;++j){pos[i][j]=0;}}

	for(i=0;i<16;++i){for(j=0;j<16;++j){for(k=0;k<16;++k){for(l=0;l<16;++l)
	{
		ba161[i][j][k][l]=-1;
	}}}}

	posi=0;
	for(a=0;a<lzi;++a)
	{
		ah=(lz[a][1]&0x0000f000)>>12;
		al=(lz[a][1]&0x00000f00)>>8;

		bh=(lz[a][1]&0x000000f0)>>4;
		bl=(lz[a][1]&0x0000000f)>>0;

		if(ba161[ah][al][bh][bl]==-1)
		{
			ba161[ah][al][bh][bl]=posi;	
			++pos[ba161[ah][al][bh][bl]][0];lind=pos[ba161[ah][al][bh][bl]][0];
			pos[ba161[ah][al][bh][bl]][lind]=a;
			++pos[ba161[ah][al][bh][bl]][0];
			++posi;
			if(posi>=posX){printf("1.Error...\n");return(0);}
		}else{

			lind=pos[ba161[ah][al][bh][bl]][0];
			pos[ba161[ah][al][bh][bl]][lind]=a;
			++pos[ba161[ah][al][bh][bl]][0];
			if(pos[ba161[ah][al][bh][bl]][0]>=posY){printf("2.Error...%d\n",a);return(0);}
			
		}
	}

	msortf2=fopen(outfn,"w");
	msortf1=fopen(infn,"rb");
	for(i=0;i<16;++i){for(j=0;j<16;++j){for(k=0;k<16;++k){for(l=0;l<16;++l)
	{
		if(ba161[i][j][k][l]!=-1)
		{
			if(pos[ba161[i][j][k][l]][0]==2)
			{
				fseek(msortf1,lz[pos[ba161[i][j][k][l]][1]][0],SEEK_SET);
				fbyte=getc(msortf1);
				a=0;while(!feof(msortf1)&&(int)fbyte!=10&&(int)fbyte!=13){fprintf(msortf2,"%c",fbyte);fbyte=getc(msortf1);++a;}if(a>0){fprintf(msortf2," \n");}
				continue;
			}
			for(i3=0;i3<pos3X;++i3){for(j3=0;j3<pos3Y;++j3){pos3[i3][j3]=0;}}
			for(i3=0;i3<16;++i3){for(j3=0;j3<16;++j3){for(k3=0;k3<16;++k3){for(l3=0;l3<16;++l3)
			{
				ba163[i3][j3][k3][l3]=-1;
			}}}}

			posi3=0;
			for(o=1;o<pos[ba161[i][j][k][l]][0];++o)
			{

				ah3=(lz[pos[ba161[i][j][k][l]][o]][1]&0x000000f0)>>4;
				al3=(lz[pos[ba161[i][j][k][l]][o]][1]&0x0000000f)>>0;

				bh3=(lz[pos[ba161[i][j][k][l]][o]][2]&0x0000f000)>>12;
				bl3=(lz[pos[ba161[i][j][k][l]][o]][2]&0x00000f00)>>8;

				if(ba163[ah3][al3][bh3][bl3]==-1)
				{
					ba163[ah3][al3][bh3][bl3]=posi3;	
					++pos3[ba163[ah3][al3][bh3][bl3]][0];lind=pos3[ba163[ah3][al3][bh3][bl3]][0];
					pos3[ba163[ah3][al3][bh3][bl3]][lind]=pos[ba161[i][j][k][l]][o];
					++pos3[ba163[ah3][al3][bh3][bl3]][0];
					++posi3;
					if(posi3>=pos3X){printf("3.Error...\n");return(0);}
				}else{
					lind=pos3[ba163[ah3][al3][bh3][bl3]][0];
					pos3[ba163[ah3][al3][bh3][bl3]][lind]=pos[ba161[i][j][k][l]][o];
					++pos3[ba163[ah3][al3][bh3][bl3]][0];
					if(pos3[ba163[ah3][al3][bh3][bl3]][0]>=pos3Y){printf("4.Error...\n");return(0);}
				}
			}

			for(i3=0;i3<16;++i3){for(j3=0;j3<16;++j3){for(k3=0;k3<16;++k3){for(l3=0;l3<16;++l3)
			{
				if(ba163[i3][j3][k3][l3]!=-1)
				{
					if(pos3[ba163[i3][j3][k3][l3]][0]==2)
					{
						fseek(msortf1,lz[pos3[ba163[i3][j3][k3][l3]][1]][0],SEEK_SET);
						fbyte=getc(msortf1);
						a=0;while(!feof(msortf1)&&(int)fbyte!=10&&(int)fbyte!=13){fprintf(msortf2,"%c",fbyte);fbyte=getc(msortf1);++a;}if(a>0){fprintf(msortf2," \n");}
						continue;
					}

					for(i5=0;i5<pos5X;++i5){for(j5=0;j5<pos5Y;++j5){pos5[i5][j5]=0;}}
					for(i5=0;i5<16;++i5){for(j5=0;j5<16;++j5){for(k5=0;k5<16;++k5){for(l5=0;l5<16;++l5)
					{
						ba165[i5][j5][k5][l5]=-1;
					}}}}

					posi5=0;
					for(o=1;o<pos3[ba163[i3][j3][k3][l3]][0];++o)
					{
		
						ah5=(lz[pos3[ba163[i3][j3][k3][l3]][o]][2]&0x000000f0)>>4;
						al5=(lz[pos3[ba163[i3][j3][k3][l3]][o]][2]&0x0000000f)>>0;

						bh5=(lz[pos3[ba163[i3][j3][k3][l3]][o]][3]&0x0000f000)>>12;
						bl5=(lz[pos3[ba163[i3][j3][k3][l3]][o]][3]&0x00000f00)>>8;

						if(ba165[ah5][al5][bh5][bl5]==-1)
						{
							ba165[ah5][al5][bh5][bl5]=posi5;	
							++pos5[ba165[ah5][al5][bh5][bl5]][0];lind=pos5[ba165[ah5][al5][bh5][bl5]][0];
							pos5[ba165[ah5][al5][bh5][bl5]][lind]=pos3[ba163[i3][j3][k3][l3]][o];
							++pos5[ba165[ah5][al5][bh5][bl5]][0];
							++posi5;
							if(posi5>=pos5X){printf("5.Error...\n");return(0);}
						}else{
							lind=pos5[ba165[ah5][al5][bh5][bl5]][0];
							pos5[ba165[ah5][al5][bh5][bl5]][lind]=pos3[ba163[i3][j3][k3][l3]][o];
							++pos5[ba165[ah5][al5][bh5][bl5]][0];
							if(pos5[ba165[ah5][al5][bh5][bl5]][0]>=pos5Y){printf("6.Error...\n");return(0);}
						}
					}

					for(i5=0;i5<16;++i5){for(j5=0;j5<16;++j5){for(k5=0;k5<16;++k5){for(l5=0;l5<16;++l5)
					{
						if(ba165[i5][j5][k5][l5]!=-1)
						{
							for(m=1;m<pos5[ba165[i5][j5][k5][l5]][0];++m)
							{
								fseek(msortf1,lz[pos5[ba165[i5][j5][k5][l5]][m]][0],SEEK_SET);
								fbyte=getc(msortf1);
								a=0;while(!feof(msortf1)&&(int)fbyte!=10&&(int)fbyte!=13){fprintf(msortf2,"%c",fbyte);fbyte=getc(msortf1);++a;}if(a>0){fprintf(msortf2," \n");}
							}
						}
					}}}}
				}
			}}}}
		}
	}}}}		
	fclose(msortf1);
	fclose(msortf2);

	return(0);
}
