
//	This source and fast ascii text file search method apply to GNU General Public License. 
//			Copyright (C) 2006 Jasenko Dzinleski 

//		This program is free software; you can redistribute it
//	and/or modify it under the terms of the GNU General Public License as
//	published by the Free Software Foundation; either version 2 of the
//	License, or (at your option) any later version. 

//	This program is distributed in the hope that it will be useful, but
//	WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
//	General Public License for more details. 

//	You should have received a copy of the GNU General Public License along
//	with this program; if not, write to the Free Software Foundation, Inc.,
//	51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.

//
//			ASCII Text File Search Routine
//			written by Dzinleski Jasenko November,2006
//

#include <stdio.h>
#include <string.h>

#define		search_bfl	7000
#define		cl		100

FILE		*search_f1,*search_f2,*search_outf;
char		search_infn[255]="iinput.txt";
char		search_infn1[255]="criteria.txt";

int		fb[search_bfl];
int		fbi;
int		fbt[search_bfl];
int		fbti;

int		ws[10][cl];
int		wsl[10];
int		wsi=0;

int		search_ba16[16][16][16][16][2];

int		search_pos[1000][search_bfl];
int		search_posi=0;

int		search_pos1[search_bfl];

long		linec[3*search_bfl][2];
long		lineci=0;

int		occ=0;
int		pmatch;

bool		search_fl=false;

int		hits[3*search_bfl];

int hc113(int spos,int sline,int eline,int ind)
{
	int		i,j,k,l,m,n;
	int		a,b;
	char		sl[255];
	
	for(i=0;i<search_bfl;++i){search_pos1[i]=-1;}
	for(i=0;i<16;++i){for(j=0;j<16;++j){for(k=0;k<16;++k){for(l=0;l<16;++l)
	{
		search_ba16[i][j][k][l][0]=-1;
		search_ba16[i][j][k][l][1]=0;
	}}}}	

	search_posi=0;
	for(i=spos;i<=search_bfl;++i)
	{
		if(search_ba16[(fb[i]&0x00f0)>>4][fb[i]&0x000f][(fb[i+1]&0x00f0)>>4][fb[i+1]&0x000f][0]==-1)
		{
			search_ba16[(fb[i]&0x00f0)>>4][fb[i]&0x000f][(fb[i+1]&0x00f0)>>4][fb[i+1]&0x000f][0]=search_posi;		
			search_pos[search_posi][search_ba16[(fb[i]&0x00f0)>>4][fb[i]&0x000f][(fb[i+1]&0x00f0)>>4][fb[i+1]&0x000f][1]]=i;
			++search_ba16[(fb[i]&0x00f0)>>4][fb[i]&0x000f][(fb[i+1]&0x00f0)>>4][fb[i+1]&0x000f][1];	
			++search_posi;
		}else{
			search_pos[search_ba16[(fb[i]&0x00f0)>>4][fb[i]&0x000f][(fb[i+1]&0x00f0)>>4][fb[i+1]&0x000f][0]][search_ba16[(fb[i]&0x00f0)>>4][fb[i]&0x000f][(fb[i+1]&0x00f0)>>4][fb[i+1]&0x000f][1]]=i;
			++search_ba16[(fb[i]&0x00f0)>>4][fb[i]&0x000f][(fb[i+1]&0x00f0)>>4][fb[i+1]&0x000f][1];				
		}

		++i;

		if(search_ba16[(fb[i]&0x00f0)>>4][fb[i]&0x000f][(fb[i+1]&0x00f0)>>4][fb[i+1]&0x000f][0]==-1)
		{
			search_ba16[(fb[i]&0x00f0)>>4][fb[i]&0x000f][(fb[i+1]&0x00f0)>>4][fb[i+1]&0x000f][0]=search_posi;		
			search_pos[search_posi][search_ba16[(fb[i]&0x00f0)>>4][fb[i]&0x000f][(fb[i+1]&0x00f0)>>4][fb[i+1]&0x000f][1]]=i;
			++search_ba16[(fb[i]&0x00f0)>>4][fb[i]&0x000f][(fb[i+1]&0x00f0)>>4][fb[i+1]&0x000f][1];	
			++search_posi;
		}else{
			search_pos[search_ba16[(fb[i]&0x00f0)>>4][fb[i]&0x000f][(fb[i+1]&0x00f0)>>4][fb[i+1]&0x000f][0]][search_ba16[(fb[i]&0x00f0)>>4][fb[i]&0x000f][(fb[i+1]&0x00f0)>>4][fb[i+1]&0x000f][1]]=i;
			++search_ba16[(fb[i]&0x00f0)>>4][fb[i]&0x000f][(fb[i+1]&0x00f0)>>4][fb[i+1]&0x000f][1];				
		}
	}

	for(i=0;i<=wsl[ind];++i)
	{
		if(search_ba16[(ws[ind][i]&0x00f0)>>4][ws[ind][i]&0x000f][(ws[ind][i+1]&0x00f0)>>4][ws[ind][i+1]&0x000f][0]==-1){}else{

			if(i==0)
			{

				for(k=search_ba16[(ws[ind][i]&0x00f0)>>4][ws[ind][i]&0x000f][(ws[ind][i+1]&0x00f0)>>4][ws[ind][i+1]&0x000f][1]-1;k>=0;--k)
				{
					j=search_pos[search_ba16[(ws[ind][i]&0x00f0)>>4][ws[ind][i]&0x000f][(ws[ind][i+1]&0x00f0)>>4][ws[ind][i+1]&0x000f][0]][k];
					search_pos1[j]=1;
				}

			}else{

				for(k=search_ba16[(ws[ind][i]&0x00f0)>>4][ws[ind][i]&0x000f][(ws[ind][i+1]&0x00f0)>>4][ws[ind][i+1]&0x000f][1]-1;k>=0;--k)
				{
					j=search_pos[search_ba16[(ws[ind][i]&0x00f0)>>4][ws[ind][i]&0x000f][(ws[ind][i+1]&0x00f0)>>4][ws[ind][i+1]&0x000f][0]][k];
					if(j-i>=0&&search_pos1[j-i]!=-1){}
				}

				++i;

				for(k=search_ba16[(ws[ind][i]&0x00f0)>>4][ws[ind][i]&0x000f][(ws[ind][i+1]&0x00f0)>>4][ws[ind][i+1]&0x000f][1]-1;k>=0;--k)
				{
					j=search_pos[search_ba16[(ws[ind][i]&0x00f0)>>4][ws[ind][i]&0x000f][(ws[ind][i+1]&0x00f0)>>4][ws[ind][i+1]&0x000f][0]][k];
					if(j-i>=0&&search_pos1[j-i]!=-1){}else{search_pos1[j]=-1;}
				}
			}
		}
	}

	if(pmatch==0)
	{
		for(i=0;i<search_bfl;++i)
		{
			if(search_pos1[i]!=-1)
			{
				for(l=sline;l<eline;++l)
				{
					if(i>=linec[l][0]&&i<=linec[l][1])
					{
						++hits[l];break;	
					}
				}
			}
		}
	}

	if(pmatch==1)
	{
		for(i=0;i<search_bfl;++i)
		{
			if(search_pos1[i]!=-1)
			{
				for(l=sline;l<eline;++l)
				{
					if(i>=linec[l][0]&&i<=linec[l][1])
					{
						for(n=0;n<255;++n){sl[n]='\0';}
						n=0;for(m=linec[l][0];m<linec[l][1];++m){sl[n]=fb[m];++n;}
						for(m=0;m<strlen(sl);++m)
						{
							for(n=0;n<wsl[ind];++n)
							{
								if(ws[ind][n]!=sl[m+n]){break;}
							}
							if(n==wsl[ind]){++hits[l];break;}
						}
							
					}
				}
			}
		}
	}

	if(pmatch==2)
	{
		if(!search_fl){for(l=sline;l<eline;++l){hits[l]=0;}}else{for(l=sline;l<eline;++l){++hits[l];}}
		if(!search_fl)
		{
			for(i=0;i<search_bfl;++i)
			{
				if(search_pos1[i]!=-1)
				{
					for(l=sline;l<eline;++l)
					{
						for(n=0;n<255;++n){sl[n]='\0';}
						n=0;for(m=linec[l][0];m<linec[l][1]&&(char)fb[m]!=' ';++m){sl[n]=(char)fb[m];++n;}
						for(m=0;m<1;++m)
						{
							for(n=0;n<wsl[ind];++n)
							{
								if(ws[ind][n]!=sl[m+n]){break;}
							}
							if(n==wsl[ind]){search_fl=true;break;}
						}
						if(search_fl){for(m=-1+l;m>=sline;--m){hits[m]=0;}for(m=l;m<eline;++m){++hits[m];}return(0);}
					}
				}
			}
		}
	}

	if(pmatch==3)
	{
		if(!search_fl){for(l=sline;l<eline;++l){++hits[l];}}else{for(l=sline;l<eline;++l){hits[l]=0;}}				
		if(!search_fl)
		{
			for(i=0;i<search_bfl;++i)
			{
				if(search_pos1[i]!=-1)
				{
					for(l=sline;l<eline;++l)
					{
						for(l=sline;l<eline;++l)
						{
							for(n=0;n<255;++n){sl[n]='\0';}
							n=0;for(m=linec[l][0];m<linec[l][1]&&(char)fb[m]!=' ';++m){sl[n]=(char)fb[m];++n;}
							for(m=0;m<1;++m)
							{
								for(n=0;n<wsl[ind];++n)
								{
									if(ws[ind][n]!=sl[m+n]){break;}
								}
								if(n==wsl[ind]){search_fl=true;break;}
							}
							if(search_fl){for(m=l;m>=sline;--m){++hits[m];}for(m=l+1;m<eline;++m){hits[m]=0;}return(0);}
						}

					}
				}
			}
		}
	}

	return(0);	
}

long hc11(long spos,bool df,char outfn[])
{
	int		i,j,l,m,r,s=1;
	int		a,b,c;
	int		fbyte;
	long		rpos;

	for(i=0;i<search_bfl;++i){fb[i]=0;}

	search_f1=fopen(search_infn,"rb");

	if(spos==0){}else{fseek(search_f1,spos,SEEK_SET);}

	fbi=0;fbti=0;fbyte=0;
	fbyte=getc(search_f1);

	while(!feof(search_f1)&&fbi<search_bfl-fbti)
	{
		fbt[fbti]=fbyte;++fbti;
		fbyte=getc(search_f1);
		if(fbyte==13||fbyte==10)
		{
			while(fbyte==13||fbyte==10){fbt[fbti]=fbyte;++fbti;fbyte=getc(search_f1);}
			if(fbi+fbti<search_bfl)
			{
				for(i=0;i<fbti;++i){fb[fbi]=fbt[i];++fbi;}	
				for(i=0;i<search_bfl;++i){fbt[i]=0;}fbti=0;
			}
		}
	}
	if(!feof(search_f1)){rpos=ftell(search_f1)-(fbi-i)+1;}else{rpos=-1;}
	fclose(search_f1);

	a=lineci;i=0;l=0;
	linec[lineci][0]=l;
	while(i<fbi)
	{
		for(i=l;i<fbi&&fb[i]!=13&&fb[i]!=10;++i){++l;}
		if(fb[i]==13){linec[lineci][1]=l;l+=2;++lineci;linec[lineci][0]=l;}
		if(fb[i]==10){linec[lineci][1]=l;++l;++lineci;linec[lineci][0]=l;}
		for(i=l;i<fbi&&(fb[i]==13||fb[i]==10);++i){++l;}
	}
	linec[lineci][1]=l;
	b=lineci;
	
	if(pmatch==2&&search_fl){for(j=a;j<b;++j){++hits[j];}}else{for(j=a;j<b;++j){hits[j]=0;}}
	
	if(pmatch==1)
	{
		for(i=0;i<wsi;++i)
		{	
			hc113(0,a,b,i);
		}
	}else{
		if(!search_fl){hc113(0,a,b,0);}
	}

	if(!df){search_outf=fopen(outfn,"a");}
	for(j=a;j<b;++j)
	{
		if(hits[j]!=0)
		{
			if(df){c=0;for(m=linec[j][0];m<linec[j][1];++m){if(fb[m]!=13&&fb[m]!=10){printf("%c",fb[m]);++c;}}if(c>0){printf("\n");}}else{
				c=0;for(m=linec[j][0];m<linec[j][1];++m){if(fb[m]!=13&&fb[m]!=10){fprintf(search_outf,"%c",fb[m]);++c;}}if(c>0){fprintf(search_outf,"\n");}
			}
			++occ;
		}
	}
	if(!df){fclose(search_outf);}

	return(rpos);
}

int t1131(int match,char search_fn1[],bool df,char outfn[])
{
	int		i,l,j,k,m;
	int		a;
	long		pos=0;
	char		cmd[255];
	char		ss[cl];
	int		cc=0;
	char		fbyte;

	//printf("\nASCII Text File Search Routine\n");
	//printf("written by Dzinleski Jasenko November,2006\n");
	//printf("\nOS Win32 VRM 1.3.3\n\n");

	pmatch=match;
	wsi=0;
	occ=0;
	search_posi=0;
	lineci=0;
	search_fl=false;
	for(j=0;j<3*search_bfl;++j){hits[j]=0;}
	strcpy(search_infn,search_fn1);

	for(j=0;j<cl;++j){ss[j]='\0';}
	search_f2=fopen(search_infn1,"rb");
	if(search_f2!=NULL)
	{
		i=0;
		fbyte=getc(search_f2);		
		while(!feof(search_f2))
		{
			ss[i]=fbyte;++i;
			fbyte=getc(search_f2);			
		}
		fclose(search_f2);

	}else{printf("No file!");return(0);}

	for(j=0;j<strlen(ss);++j){if(ss[j]=='+'){++cc;}}
	l=0;m=0;
	while(l<=cc)
	{
		for(j=0;j<cl;++j){ws[l][j]='\0';}
		for(j=m;j<strlen(ss)&&ss[j]!='+';++j)
		{
			ws[l][j-m]=ss[j];
		}
		wsl[l]=j-m;
		//for(j=0;j<wsl[l];++j){printf("%c",ws[l][j]);}printf(" ");//printf("%d",wsl[l]);
		++l;m+=j+1;++wsi;
	}
	//printf("\n");

	search_f1=fopen(search_infn,"rb");
	if(search_f1!=NULL)
	{
		fclose(search_f1);

		//printf(" %s %d",search_infn,ws[ind]);
		//printf(" %s %s %d",search_infn,ws[1],wsi[1]);
		//printf(" %s %s %d",search_infn,ws[2],wsi[2]);

		while(pos!=-1){pos=hc11(pos,df,outfn);}
							
	}else{printf("No file!");}

	//printf("Total occurences found:%d\n",occ);
	//printf("\nOk");

	return(occ);
}